
function getSettingsBlkLoadPath(path)
{
  if (!(::develop)) {

    local basePath = ::makeFullPath(::getMyDocuments(), ::my_documents);
    local filePath = ::makeFullPath(basePath, path);

    if (::fileExists(filePath))
      return filePath;
    return ::makeFullPath(::getGameFolder(), path);
//    return path;
  }
  else
    return ::makeFullPath(::getGameFolder(), path);
}


function getSettingsBlkSavePath(path)
{
  if (!(::develop)) 
  {
    local basePath = ::makeFullPath(::getMyDocuments(), ::my_documents);
    local filePath = ::makeFullPath(basePath, path);

    ::createPath(filePath);

    return filePath;

//    ::createPath(path);
//    return path;
  }
  else
    return ::makeFullPath(::getGameFolder(), path);
}

function getGameFolder()
{
  if (!(::develop))
  {

    local gameFolder = ::getCurDir();

    local regGameDir =
       ::getRegString(::HKEY_LOCAL_MACHINE, ::registry_path, "Path", "");

    if (regGameDir == "")
      regGameDir = ::getRegString(::HKEY_CURRENT_USER, ::registry_path, "Path", "");

    if (regGameDir != "")
      gameFolder = ::getFolder(regGameDir);

    return gameFolder;
  }
  else
    return ::getCurDir();
}

function isInstalled()
{
  if (!(::develop))
  {
    local regGameDir =
       ::getRegString(::HKEY_LOCAL_MACHINE, ::registry_path, "Path", "");

    if (regGameDir == "")
      regGameDir = ::getRegString(::HKEY_CURRENT_USER, ::registry_path, "Path", "");

    if (regGameDir != "")
      return true;

    return false;
  }
  else
    return true;
}

function runGameBtnMouseDown()
{
  local yuState = ::getYuplayStatus()
  if (yuState == YUPLAY_NONE)
  {
    ::errorMessageUtf(::getLocText("yuplay/not_installed1"), "")
    return    
  }
  if (::app_state_result < 0)
  {
    ::errorMessageUtf(::getLocText("yuplay/checking"), "")
    return    
  }
  if (::app_state_result == 0)
  {
    ::errorMessageUtf(::getLocText("error/need_activate"), "")
    ::yuStatePrev = -1 //to refresh a window
    ::fastActivate()
    return    
  }
  saveAllSettings();
  local res=::executeProcess(getGameExePath(), "", "", SW_SHOWNORMAL);
  if (!res) {
    ::errorMessage("File not found!", "Start Game");
  }
  else {
    ::sleep(200);
    ::exit();
  }
}

