includeScript("blk.nut");

//global names
::registry_path <- "Software\\Activision\\Apache";
::my_documents <- "My Games/Apache/";
::settings_blk_path <-  "..\\develop\\gamebase\\_pc\\settings.blk";
::game_version <- ::getLocText("game_version");
::isDemo <- false;
if (::getLocText("isDemo") == "yes") {
  ::isDemo <- true;
  ::registry_path <- "Software\\Activision\\Apache Demo";
}
::develop <- false;
::yuplay_GUID <- ::getLocText("yuplay_GUID");
::yuplay_GUID2 <- ::getLocText("yuplay_GUID2");
::exeName <- "apache.exe";

includeScript("release.nut");
includeScript("develop.nut");
if (!(::isDemo)){
  includeScript("yuplay.nut");
}
else
{
  function setYuplayHtml(){
    ::setHtmlRaw("yuplay", "<b>" + ::getLocText("demo_version") + "</b>");
  }
}

if (::develop) 
  ::exeName <- "z.bat";



//----------------------------- Settings schemes
::settings_scheme <-
{
  graphicsQuality={ type="string" defVal="high" blk="graphicsQuality" }
  language={ type="string" defVal=getLanguage() blk="language" }
 
  resolution={ type="string" defVal="1024 x 768" blk="video/resolution" }
  windowed={ type="bool" defVal=false blk="video/windowed" }
  vsync={ type="bool" defVal=false blk="video/vsync" }
  shadows={ type="bool" defVal=true blk="render/shadows" }
  selfShadows={ type="bool" defVal=true blk="render/selfShadows" }
  selfReflection={ type="bool" defVal=true blk="render/selfReflection" }
  waterReflection={ type="bool" defVal=true blk="render/waterReflection" }
  motionBlur={ type="bool" defVal=true blk="render/motionBlur" }
  haze={ type="bool" defVal=true blk="render/haze" }
  softFx={ type="bool" defVal=true blk="render/softFx" }
  grass={ type="bool" defVal=true blk="render/grass" }
  vignette = { type="bool" defVal=true blk="debug/noVignette"
    getFromBlk=function(blk, desc) { return !::get_blk_bool(blk, desc.blk, false); }
    setToBlk=function(blk, desc, val) { ::set_blk_bool(blk, desc.blk, !val); }
  }

  jpegShots={ type="bool" defVal=true blk="debug/screenshotAsJpeg" }
  videoRAMwarningOff={ type="bool" defVal=false blk="debug/512mboughttobeenoughforanybody" }

  mouse_sensX={
    type="real" defVal=0.5 blk="mouse/sensX"
    getFromBlk=function(blk, desc) {
      local val = ::get_blk_real(blk, desc.blk, 0.5) * 100;
      return val.tointeger();
    }
    setToBlk=function(blk, desc, val) { ::set_blk_real(blk, desc.blk, val/100.0); }
  }
//  mouse_invertX={ type="bool" defVal=false blk="mouse/invertX" }
  mouse_invertY={ type="bool" defVal=false blk="mouse/invertY" }
  mouse_sensY={
    type="real" defVal=0.5 blk="mouse/sensY"
    getFromBlk=function(blk, desc) {
      local val = ::get_blk_real(blk, desc.blk, 0.5) * 100;
      return val.tointeger();
    }
    setToBlk=function(blk, desc, val) { ::set_blk_real(blk, desc.blk, val/100.0); }
  }
  mouse_sensZ={
    type="real" defVal=1 blk="mouse/sensZ"
    getFromBlk=function(blk, desc) {
      local val = ::get_blk_real(blk, desc.blk, 1.0) * 100;
      return val.tointeger();
    }
    setToBlk=function(blk, desc, val) { ::set_blk_real(blk, desc.blk, val/100.0); }
  }

/*  gamma=
  {
    type="real" defVal=1.0 blk="graphics/gamma"
    getFromBlk=function(blk, desc) {
      local val = ::get_blk_real(blk, desc.blk, 1.0) * 100 - 50;
      return val.tointeger();
    }
    setToBlk=function(blk, desc, val) { ::set_blk_real(blk, desc.blk, (val + 50) / 100.0); }
  }
*/

  antialias=
  {
    type="string" defVal="off" blk="directx/maxaa"
    getFromBlk=function(blk, desc) { 
      local aa = ::get_blk_int(blk, desc.blk, 0);
      if (aa == 4) return "4X";
      if (aa == 2) return "2X";
      if (aa == 6) return "6X";
      return "off";
    }
    setToBlk=function(blk, desc, val) {
      local aa = 0;
      if (val == "6X") aa = 6;
      if (val == "4X") aa = 4;
      if (val == "2X") aa = 2;
      ::set_blk_int(blk, desc.blk, aa); 
    }
  }
  anisotropy=
  {
    type="string" defVal="" blk="graphics/anisotropy"
    getFromBlk=function(blk, desc) { 
      local anis = ::get_blk_int(blk, desc.blk, 2);
      if (anis == 16) return "16X";
      if (anis == 8) return "8X";
      if (anis == 4) return "4X";
      if (anis == 2) return "2X";
      return "off";
    }
    setToBlk=function(blk, desc, val) {
      local anis = 1;
      if (val == "16X") anis = 16;
      if (val == "8X") anis = 8;
      if (val == "4X") anis = 4;
      if (val == "2X") anis = 2;
      ::set_blk_int(blk, desc.blk, anis); 
    }
  }
  texQuality={ type="string" defVal="high" blk="graphics/texquality" }
  visRange={ type="string" defVal="high" blk="graphics/visRange" }
  
//sound
  sound={ type="bool" defVal=true blk="sound/fmod_sound_enable" }
//  subtitles= { type="bool" defVal=true blk="game/subtitles"}
  CHECK_UPDATES = { type="bool" defVal=true blk="autocheck" }
};


::settings <- null;


//----------------------------- Message handlers

function checkFilesBtnDown()
{
  ::shellExecute("hashChecker.exe", "", "", SW_SHOWNORMAL);
}

function onApplicationStart()
{
  if (!::isInstalled())
    ::shellExecute("setup.exe", "", "redist", SW_SHOWNORMAL);

  ::registerCallbacks(getGameFolder, getGameExePath, null, null,
    null, null, null);
  ::getVideoModes("resolution");
  ::settings = ::Settings("config.blk", ::settings_scheme);
  if (::develop) 
    ::gamelaunch_settings.updateGui();
  ::settings.updateGui();

  ::setAvailableLanguages();
  ::setYuplayHtml();
  ::setVersionHtml();
  ::setValue("language", getLanguage());
  
  return true;
}


function on3SecTick()
{
  ::setYuplayHtml();
  ::setVersionHtml();
}


function onInitComplete()
{
//  ::reverbSet()
  ::setGraphicsQuality();
  ::windowedClick();
}

function onApplicationClose(){}

function getSteamExeName()
{
  local regGameDir =
     ::getRegString(::HKEY_LOCAL_MACHINE, ::registry_path, "SteamLaunch", "");

  if (regGameDir == "")
    regGameDir = ::getRegString(::HKEY_CURRENT_USER, ::registry_path, "SteamLaunch", "");

    return regGameDir;
}

function isSteamInstalled()
{
//  return (getSteamExeName() != "");
  return false;

}


function getGameExePath()
{
  if (!::develop)
    if (isSteamInstalled())
      return getSteamExeName();
  return ::makeFullPath(::getGameFolder(), ::exeName);
}

function exitBtnMouseDown()
{
  ::exit();
}

function exitAndSaveBtnMouseDown()
{
  local lang = ::getValue("language", getLanguage())
  if (lang != null)
    setLanguage(::getValue("language", getLanguage()));
  saveAllSettings();
  ::exit();
}
function langChanged()
{
  local lang = ::getValue("language", getLanguage())
  if (lang != null)
    setLanguage(::getValue("language", getLanguage()));
  restartLauncher();
}


function setGraphicsQuality()
{
  local quality = ::getValue("graphicsQuality", "high");
  if (quality=="custom")
  {
    return;
  }
  if (quality=="max")
  {
    ::setValue("anisotropy", "16X");
    ::setValue("vsync", true);
    ::setValue("antialias", "4X");
    if (::isDemo)
      ::setValue("texQuality", "high");
    else
      ::setValue("texQuality", "ultrahigh");
    ::setValue("visRange", "high");
    ::setValue("shadows", true);
    ::setValue("selfShadows", true);
    ::setValue("selfReflection", true);
    ::setValue("waterReflection", true);
    ::setValue("motionBlur", true);
    ::setValue("haze", true);
    ::setValue("grass", true);
    ::setValue("softFx", true);
    ::setValue("vignette", true);
    return;
  }
  if (quality=="high")
  {
    ::setValue("anisotropy", "8X");
    ::setValue("vsync", false);
    ::setValue("antialias", "2X");
    ::setValue("texQuality", "high");
    ::setValue("visRange", "high");
    ::setValue("shadows", true);
    ::setValue("selfShadows", true);
    ::setValue("selfReflection", true);
    ::setValue("waterReflection", true);
    ::setValue("motionBlur", true);
    ::setValue("haze", true);
    ::setValue("grass", true);
    ::setValue("softFx", true);
    ::setValue("vignette", true);
    return;
  }
  if (quality=="low")
  {
    ::setValue("anisotropy", "off");
    ::setValue("vsync", false);
    ::setValue("antialias", "off");
    ::setValue("texQuality","medium");
    ::setValue("visRange", "low");
    ::setValue("shadows", false);
    ::setValue("selfShadows", true);
    ::setValue("selfReflection", true);
    ::setValue("waterReflection", false);
    ::setValue("motionBlur", false);
    ::setValue("haze", false);
    ::setValue("softFx", false);
    ::setValue("grass", false);
    ::setValue("vignette", true);
    return;
  }
  if (quality=="ultralow")
  {
    ::setValue("anisotropy", "off");
    ::setValue("vsync", false);
    ::setValue("antialias", "off");
    ::setValue("texQuality","low");
    ::setValue("visRange", "low");
    ::setValue("shadows", false);
    ::setValue("selfShadows", false);
    ::setValue("selfReflection", false);
    ::setValue("waterReflection", false);
    ::setValue("motionBlur", false);
    ::setValue("grass", false);
    ::setValue("haze", false);
    ::setValue("softFx", false);
    ::setValue("vignette", true);
    return;
  }
  else
  {
    ::setValue("anisotropy", "2X");
    ::setValue("vsync", false);
    ::setValue("antialias", "off");
    ::setValue("texQuality", "high");
    ::setValue("visRange", "medium");
    ::setValue("shadows", true);
    ::setValue("selfShadows", true);
    ::setValue("selfReflection", true);
    ::setValue("waterReflection", true);
    ::setValue("motionBlur", false);
    ::setValue("haze", false);
    ::setValue("grass", true);
    ::setValue("softFx", true);
    ::setValue("vignette", true);
  }
}
function graphicsQualityClick()
{
  setGraphicsQuality();
}
function advancedClick()
{
  ::setValue("graphicsQuality", "custom");
}
function vsyncClick()
{
  ::setValue("graphicsQuality", "custom");
}

function windowedClick()
{
  if (!(::isChecked("windowed")))
    ::enable("vsync");
  else
    ::disable("vsync");
}

function soundClick(){
  if (!(::isChecked("sound")))
    ::disable("speaker");
  else
    ::enable("speaker");
}

function saveAllSettings()
{
  ::setGraphicsQuality();
  ::windowedClick();
  ::settings.save();
  if (develop) 
    ::gamelaunch_settings.save();
}
function setVersionHtml()
{
  if (!(::isDemo))
    ::setHtmlRaw("gameversion", ::game_version);
  else
    ::setHtmlRaw("gameversion",::getLocText("demo_version"));
}
function setAvailableLanguages()
{
  if (::develop){
    return;
  }
  local isEFGS = ::getRegString(::HKEY_LOCAL_MACHINE, ::registry_path, "isEFGS", "no");
//  local isEFGS_CU = ::getRegString(::HKEY_CURRENT_USER, ::registry_path, "isEFGS", "no");
  local isRu = ::getRegString(::HKEY_LOCAL_MACHINE, ::registry_path, "isRu", "no");
//  local isRu_CU = "no"//::getRegString(::HKEY_CURRENT_USER, ::registry_path, "isRu", "no");
  local isPo = ::getRegString(::HKEY_LOCAL_MACHINE, ::registry_path, "isPo", "no");
//  local isPo_CU = ::getRegString(::HKEY_CURRENT_USER, ::registry_path, "isPo", "no");
/*
  if (isRu_CU =="yes")
    isRu="yes"
  if (isPo_CU =="yes")
    isPo="yes"
  if (isEFGS_CU =="yes")
    isEFGS="yes"
*/
  local html = ""
  if (isEFGS == "yes")
    html = "<option value=\"English\" selected>English</option><option value=\"French\">Français</option><option value=\"Spanish\">Español</option><option value=\"German\">Deutsch</option>"
  if (isRu == "yes")
    html += "<option value=\"Russian\">Русский</option>"
  if (isPo == "yes")
    html += "<option value=\"Polish\">Polski</option>"
  if ((isEFGS == "yes") || (isPo == "yes") || (isRu == "yes"))
    ::setHtmlRaw("language",html);
/*
  if (html.find("value=\""+getLanguage()+"\"") == null)
  {
    local nl = html
    local ex = regexp("<option value=\"")
    local res = ex.search(nl);
    nl.slice(-1,res.begin)
//    ::setValue("language", nl);
//    setLanguage(nl)
  }
*/
}
